/**
 * ActuadorApp.h:  fichero de definiciones de la aplicación ActuadorApp.
 *
 * @author Agustín Isasa | UOC
 * @date Abril 2012
 */

#ifndef ACTUADORAPP_H
#define ACTUADORAPP_H

enum {
	// Def comandos/mensajes entre nodo actuador y control, y registro en log
	NO_COMMAND,				// Definiciones para CommandMsg y SensorMsg
	COMM_MOTOR_OPEN,
	COMM_MOTOR_CLOSE,
	BLIND_CLOSED,			// Definiciones para HallMsg
	BLIND_NOT_CLOSED,
	HALL_EVENT,				// Genérico cuando se dispara sensor
	// Tipos de mensaje
	AM_SENSORSMSG	= 40,
	AM_COMMANDMSG	= 41,
	AM_HALLMSG		= 42
};

// Mensaje radio con comando a nodo actuador
typedef nx_struct CommandMsg{
	nx_uint8_t moteId;		// Identificador mote
	nx_uint8_t cmd;			// Comando transmitido
	nx_uint8_t timeCmd;		// Tiempo actuación sobre motor
}CommandMsg;

// Mensaje correspondiente a evento Hall
typedef nx_struct HallMsg{	
	nx_uint8_t moteId;		// Identificador mote
	nx_uint16_t eventNumber;// Contador
	nx_uint8_t blindState;	// Persiana cerrada o no cerrada
}HallMsg;

#endif /* ACTUADORAPP_H */
