/**
 *
 * @author Agustin Isasa | UOC | PFC | Sistemas empotrados
 */ 
import java.io.*;
import java.util.Date;
import net.tinyos.message.Message;
import net.tinyos.message.MessageListener;
import net.tinyos.message.MoteIF;
import net.tinyos.packet.BuildSource;
import net.tinyos.packet.PhoenixSource;
import net.tinyos.util.PrintStreamMessenger;

public class BlindControlGUI extends javax.swing.JFrame implements MessageListener {

  //public static BlindControlGUI instance = null;	// Instancia de esta clase
  MoteIF mif;                     // Objeto MoteIF para recibir mensajes...
  MoteIF mif2;                    // ...y otro para enviar mensajes a la mota
  Date now;                       // Marca de tiempo para entradas en log
  static File log;                // Archivo de texto log
  static DataOutputStream dos;    // Filtro para flujo bytes con fichero log
  // Definiciones para CommandMsg, SensorMsg y HallMsg
  static final int NO_COMMAND = 0;
  static final int COMM_MOTOR_OPEN = 1;
  static final int COMM_MOTOR_CLOSE = 2;
  static final int BLIND_CLOSED = 3;
  static final int BLIND_NOT_CLOSED = 4;
  BufferedReader keyb = new BufferedReader(new InputStreamReader(System.in));
  int tMin = 20, tMax = 24, freq = 15;	// Parámetros sistema por defecto
  String editor = "gedit";

  /**
   * Creates new form Interface and TOS objects
   */
  public BlindControlGUI() throws Exception {
    initComponents();
    log = new File("Blind_Control_Log.txt");      // Creamos fichero log
    dos = new DataOutputStream(new FileOutputStream(log, true));
    PhoenixSource phoenix; 
    String source = "serial@/dev/ttyUSB0:57600";  // MOTECOM 
    phoenix = BuildSource.makePhoenix(source, PrintStreamMessenger.err);
    this.mif = new MoteIF(phoenix); 
    this.mif2 = new MoteIF(phoenix);
    this.mif.registerListener(new SensorsMsg(), this);
    this.mif.registerListener(new HallMsg(), this);
    this.mif.registerListener(new ParamMsg(), this);
  }

  /**
   * This method is called from within the constructor to initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is always
   * regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">
  private void initComponents() {

    jTextField1 = new javax.swing.JTextField();
    jSeparator1 = new javax.swing.JSeparator();
    jTextField2 = new javax.swing.JTextField();
    jLabel1 = new javax.swing.JLabel();
    jLabel2 = new javax.swing.JLabel();
    jLabel3 = new javax.swing.JLabel();
    tempMaxNew = new javax.swing.JTextField();
    tempMinAct = new javax.swing.JTextField();
    freqAct = new javax.swing.JTextField();
    jSeparator2 = new javax.swing.JSeparator();
    jTextField6 = new javax.swing.JTextField();
    jLabel4 = new javax.swing.JLabel();
    jLabel5 = new javax.swing.JLabel();
    jLabel6 = new javax.swing.JLabel();
    jButton1 = new javax.swing.JButton();
    jButton3 = new javax.swing.JButton();
    jSeparator3 = new javax.swing.JSeparator();
    jLabel7 = new javax.swing.JLabel();
    jTextField3 = new javax.swing.JTextField();
    tempMaxAct = new javax.swing.JTextField();
    tempMinNew = new javax.swing.JTextField();
    freqNew = new javax.swing.JTextField();
    jLabel8 = new javax.swing.JLabel();
    jLabel9 = new javax.swing.JLabel();
    jLabel10 = new javax.swing.JLabel();
    jButton4 = new javax.swing.JButton();
    jSeparator4 = new javax.swing.JSeparator();
    jTextField4 = new javax.swing.JTextField();
    editorNew = new javax.swing.JTextField();
    menuBar = new javax.swing.JMenuBar();
    fileMenu = new javax.swing.JMenu();
    exitMenuItem = new javax.swing.JMenuItem();
    helpMenu = new javax.swing.JMenu();
    aboutMenuItem = new javax.swing.JMenuItem();

    setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
    setTitle("Blind Control 1.0");
    setPreferredSize(new java.awt.Dimension(457, 720));
    setResizable(false);

    jTextField1.setBackground(new java.awt.Color(240, 240, 240));
    jTextField1.setEditable(false);
    jTextField1.setFont(new java.awt.Font("Tahoma", 1, 46)); // NOI18N
    jTextField1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
    jTextField1.setText("Blind Control 1.0");

    jTextField2.setBackground(new java.awt.Color(240, 240, 240));
    jTextField2.setEditable(false);
    jTextField2.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
    jTextField2.setText("Menu principal:");

    jLabel1.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
    jLabel1.setText("Temperatura máxima");

    jLabel2.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
    jLabel2.setText("Temperatura mínima");

    jLabel3.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
    jLabel3.setText("Frecuencia de muestreo");

    tempMaxNew.setHorizontalAlignment(javax.swing.JTextField.RIGHT);

    tempMinAct.setBackground(new java.awt.Color(204, 204, 204));
    tempMinAct.setEditable(false);
    tempMinAct.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
    //tempMinAct.setText("20");

    freqAct.setBackground(new java.awt.Color(204, 204, 204));
    freqAct.setEditable(false);
    freqAct.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
    //freqAct.setText("15");

    jTextField6.setBackground(new java.awt.Color(240, 240, 240));
    jTextField6.setEditable(false);
    jTextField6.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
    jTextField6.setText("Parámetros ahora:");

    jLabel4.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
    jLabel4.setText("º C");

    jLabel5.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
    jLabel5.setText("º C");

    jLabel6.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
    jLabel6.setText("Minutos");

    jButton1.setBackground(new java.awt.Color(255, 204, 102));
    jButton1.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
    jButton1.setText("Revisar log");
    jButton1.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton1ActionPerformed(evt);
      }
    });

    jButton3.setBackground(new java.awt.Color(255, 153, 102));
    jButton3.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
    jButton3.setText("OK");
    jButton3.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton3ActionPerformed(evt);
      }
    });

    jLabel7.setText("Agustín Isasa | UOC | PFC | Sistemas Empotrados | Junio 2012");

    jTextField3.setBackground(new java.awt.Color(204, 204, 204));
    jTextField3.setEditable(false);
    jTextField3.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
    jTextField3.setHorizontalAlignment(javax.swing.JTextField.CENTER);
    jTextField3.setText("Modif. parámetros:");

    tempMaxAct.setBackground(new java.awt.Color(204, 204, 204));
    tempMaxAct.setEditable(false);
    tempMaxAct.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
    //tempMaxAct.setText("24");

    tempMinNew.setHorizontalAlignment(javax.swing.JTextField.RIGHT);

    freqNew.setHorizontalAlignment(javax.swing.JTextField.RIGHT);

    jLabel8.setText("Temp. máxima");

    jLabel9.setText("Temp. mínima");

    jLabel10.setText("Frec. muestreo");

    jButton4.setBackground(new java.awt.Color(255, 102, 102));
    jButton4.setText("OK");
    jButton4.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton4ActionPerformed(evt);
      }
    });

    jTextField4.setBackground(new java.awt.Color(204, 204, 204));
    jTextField4.setEditable(false);
    jTextField4.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
    jTextField4.setHorizontalAlignment(javax.swing.JTextField.CENTER);
    jTextField4.setText("Cambiar editor:");

    editorNew.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N

    fileMenu.setMnemonic('f');
    fileMenu.setText("File");

    exitMenuItem.setMnemonic('x');
    exitMenuItem.setText("Exit");
    exitMenuItem.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(java.awt.event.ActionEvent evt) {
        exitMenuItemActionPerformed(evt);
      }
    });
    fileMenu.add(exitMenuItem);

    menuBar.add(fileMenu);

    helpMenu.setMnemonic('h');
    helpMenu.setText("Help");

    aboutMenuItem.setMnemonic('a');
    aboutMenuItem.setText("About");
    helpMenu.add(aboutMenuItem);

    menuBar.add(helpMenu);

    setJMenuBar(menuBar);

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
    getContentPane().setLayout(layout);
    layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addComponent(jSeparator1, javax.swing.GroupLayout.Alignment.TRAILING).addComponent(jSeparator2).addComponent(jSeparator3, javax.swing.GroupLayout.Alignment.TRAILING).addGroup(layout.createSequentialGroup().addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addGroup(layout.createSequentialGroup().addContainerGap().addComponent(jTextField1, javax.swing.GroupLayout.DEFAULT_SIZE, 425, Short.MAX_VALUE)).addGroup(layout.createSequentialGroup().addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addGroup(layout.createSequentialGroup().addGap(37, 37, 37).addComponent(jTextField6, javax.swing.GroupLayout.PREFERRED_SIZE, 204, javax.swing.GroupLayout.PREFERRED_SIZE)).addGroup(layout.createSequentialGroup().addGap(36, 36, 36).addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false).addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addComponent(jTextField2, javax.swing.GroupLayout.PREFERRED_SIZE, 204, javax.swing.GroupLayout.PREFERRED_SIZE).addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup().addComponent(jTextField3, javax.swing.GroupLayout.PREFERRED_SIZE, 132, javax.swing.GroupLayout.PREFERRED_SIZE).addGap(18, 18, 18).addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addGroup(layout.createSequentialGroup().addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addComponent(jLabel8).addComponent(jLabel9)).addGap(14, 14, 14).addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addComponent(tempMaxNew, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE).addGroup(layout.createSequentialGroup().addComponent(tempMinNew, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE).addGap(18, 18, 18).addComponent(jButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 98, javax.swing.GroupLayout.PREFERRED_SIZE)))).addGroup(layout.createSequentialGroup().addComponent(jLabel10).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED).addComponent(freqNew, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)))).addComponent(jSeparator4, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 380, javax.swing.GroupLayout.PREFERRED_SIZE)).addGroup(layout.createSequentialGroup().addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false).addComponent(jButton1, javax.swing.GroupLayout.DEFAULT_SIZE, 132, Short.MAX_VALUE).addComponent(jTextField4)).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED).addComponent(editorNew).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED).addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 99, javax.swing.GroupLayout.PREFERRED_SIZE))))).addGap(0, 0, Short.MAX_VALUE))).addContainerGap()).addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup().addGap(0, 0, Short.MAX_VALUE).addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup().addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING).addComponent(jLabel3).addComponent(jLabel2, javax.swing.GroupLayout.Alignment.LEADING).addComponent(jLabel1, javax.swing.GroupLayout.Alignment.LEADING)).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED).addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false).addComponent(tempMinAct).addComponent(freqAct).addComponent(tempMaxAct, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 31, Short.MAX_VALUE)).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED).addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addComponent(jLabel5).addComponent(jLabel6).addComponent(jLabel4)).addGap(63, 63, 63)).addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup().addComponent(jLabel7).addContainerGap()))));
    layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addGroup(layout.createSequentialGroup().addGap(23, 23, 23).addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, 84, javax.swing.GroupLayout.PREFERRED_SIZE).addGap(18, 18, 18).addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED).addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addGroup(layout.createSequentialGroup().addComponent(jTextField6, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED).addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE).addComponent(jLabel1).addComponent(jLabel4))).addComponent(tempMaxAct, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED).addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE).addComponent(tempMinAct, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE).addComponent(jLabel2).addComponent(jLabel5)).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED).addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE).addComponent(jLabel3).addComponent(freqAct, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE).addComponent(jLabel6)).addGap(18, 18, 18).addComponent(jSeparator2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED).addComponent(jTextField2, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE).addGap(18, 18, 18).addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE).addGap(21, 21, 21).addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE).addComponent(jTextField4, javax.swing.GroupLayout.PREFERRED_SIZE, 41, javax.swing.GroupLayout.PREFERRED_SIZE).addComponent(editorNew, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE).addComponent(jButton3)).addGap(18, 18, 18).addComponent(jSeparator4, javax.swing.GroupLayout.PREFERRED_SIZE, 3, javax.swing.GroupLayout.PREFERRED_SIZE).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED).addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE).addComponent(tempMaxNew, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE).addComponent(jLabel8)).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED).addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE).addComponent(tempMinNew, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE).addComponent(jLabel9).addComponent(jButton4).addComponent(jTextField3, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED).addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE).addComponent(jLabel10).addComponent(freqNew, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)).addGap(18, 18, 18).addComponent(jSeparator3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED).addComponent(jLabel7).addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)));

    pack();
  }// </editor-fold>

  private void exitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {
    System.exit(0);
  }

  private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {
    // Arrancamos visor/editor con el fichero log como parámetro 
    Runtime rt = Runtime.getRuntime();
    try {
      Process pr = rt.exec(editor + " Blind_Control_Log.txt");
    } catch (IOException e) {
      System.err.println("  Error:  no se ha podido arrancar el visor del log");
      System.err.println("          Comprobar nombre y/o acceso al editor");
      return;
    }
    println("  --Log abierto con " + editor);
  }

  private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {
    // Obtenemos nombre del nuevo editor de su cuadro de texto, y borramos
    editor = editorNew.getText();
    editorNew.setText("");
  }

  private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {
    // Obtenemos nuevos parámetros de sus cuadros de texto 
    tMin = Integer.parseInt(tempMinNew.getText());
    tMax = Integer.parseInt(tempMaxNew.getText());
    freq = Integer.parseInt(freqNew.getText());
    // Enviamos nuevos parámetros a la mota
    println("  --Enviando mensaje a nodo control con los nuevos parámetros...");
    ParamMsg msg = new ParamMsg();
    msg.set_tMin((short) tMin);
    msg.set_tMax((short) tMax);
    msg.set_freqOp(freq);
    try { mif2.send(1, msg);
    } catch (IOException e) {
      System.err.println("  Error: no se ha podido enviar mensaje al nodo");
      //return;
    }
    println("  --Nuevos parámetros del sistema fijados");
    // Registramos en log
    now = new Date();
    printLog(now.toString()+" - Nuevos parámetros:  tempMax = "+tMax+"; tempMin = "+tMin+"; freq = "+freq+'\r'+'\n');
    // Volcamos a interface los nuevos parámetros
    tempMinAct.setText(Integer.toString(tMin));
    tempMaxAct.setText(Integer.toString(tMax));
    freqAct.setText(Integer.toString(freq));
    // Borramos de los cuadros de texto los parámetros introducidos
    tempMinNew.setText("");
    tempMaxNew.setText("");
    freqNew.setText("");
  }

  /**
   * @param args the command line arguments
   */
  public static void main(String args[]) {
    /*
     * Set the Nimbus look and feel
     */
    //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /*
     * If Nimbus (introduced in Java SE 6) is not available, stay with the
     * default look and feel. For details see
     * http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html
     */
    try {
      for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
        if ("Nimbus".equals(info.getName())) {
          javax.swing.UIManager.setLookAndFeel(info.getClassName());
          break;
        }
      }
    } catch (ClassNotFoundException ex) {
      java.util.logging.Logger.getLogger(BlindControlGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
    } catch (InstantiationException ex) {
      java.util.logging.Logger.getLogger(BlindControlGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
    } catch (IllegalAccessException ex) {
      java.util.logging.Logger.getLogger(BlindControlGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
    } catch (javax.swing.UnsupportedLookAndFeelException ex) {
      java.util.logging.Logger.getLogger(BlindControlGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
    }
    //</editor-fold>

    /*
     * Create and display the form
     */
    java.awt.EventQueue.invokeLater(new Runnable() {

      public void run() {
        try {
          new BlindControlGUI().setVisible(true);
        } catch (Exception ex) {
          java.util.logging.Logger.getLogger(BlindControlGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
      }
    });
  }

  @Override
  public void messageReceived(int to, Message m) {
    now = new Date();
    if (m instanceof SensorsMsg) {
      SensorsMsg sm = (SensorsMsg) m;
      printLog(now.toString() + " - COUNTER: " + sm.get_counter() + "\tC_PHOTO: " + sm.get_countsPhoto() + "\tTEMP: " + sm.get_countsTemp() / 15 + "ºC" + "\tmoteId: " + sm.get_moteId() + '\r' + '\n');
      if (sm.get_commnd() == NO_COMMAND) {
        printLog("                               ");
        printLog("COMMAND: No hay comando" + '\r' + '\n');
      } else if (sm.get_commnd() == COMM_MOTOR_OPEN) {
        printLog("                               ");
        printLog("COMMAND: Abrir persiana" + "\tTIEMPO: " + sm.get_timeCmd() + '\r' + '\n');
      } else if (sm.get_commnd() == COMM_MOTOR_CLOSE) {
        printLog("                               ");
        printLog("COMMAND: Cerrar persiana" + "\tTIEMPO: " + sm.get_timeCmd() + '\r' + '\n');
      }
    } else if (m instanceof HallMsg) {
      HallMsg ham = (HallMsg) m;
      printLog(now.toString() + " - HALL EVENT número: " + ham.get_eventNumber());
      if (ham.get_blindState() == BLIND_CLOSED) {
        printLog(":  Persiana cerrada" + '\r' + '\n');
      }
      if (ham.get_blindState() == BLIND_NOT_CLOSED) {
        printLog(" Persiana no cerrada" + '\r' + '\n');
      }
    } else {
      System.err.println("  Error:  mensaje inesperado con amType " + m.amType());
    }
  }
  // Variables declaration - do not modify
  private javax.swing.JMenuItem aboutMenuItem;
  private javax.swing.JTextField editorNew;
  private javax.swing.JMenuItem exitMenuItem;
  private javax.swing.JMenu fileMenu;
  private javax.swing.JTextField freqAct;
  private javax.swing.JTextField freqNew;
  private javax.swing.JMenu helpMenu;
  private javax.swing.JButton jButton1;
  private javax.swing.JButton jButton3;
  private javax.swing.JButton jButton4;
  private javax.swing.JLabel jLabel1;
  private javax.swing.JLabel jLabel10;
  private javax.swing.JLabel jLabel2;
  private javax.swing.JLabel jLabel3;
  private javax.swing.JLabel jLabel4;
  private javax.swing.JLabel jLabel5;
  private javax.swing.JLabel jLabel6;
  private javax.swing.JLabel jLabel7;
  private javax.swing.JLabel jLabel8;
  private javax.swing.JLabel jLabel9;
  private javax.swing.JSeparator jSeparator1;
  private javax.swing.JSeparator jSeparator2;
  private javax.swing.JSeparator jSeparator3;
  private javax.swing.JSeparator jSeparator4;
  private javax.swing.JTextField jTextField1;
  private javax.swing.JTextField jTextField2;
  private javax.swing.JTextField jTextField3;
  private javax.swing.JTextField jTextField4;
  private javax.swing.JTextField jTextField6;
  private javax.swing.JMenuBar menuBar;
  private javax.swing.JTextField tempMaxAct;
  private javax.swing.JTextField tempMaxNew;
  private javax.swing.JTextField tempMinAct;
  private javax.swing.JTextField tempMinNew;
  // End of variables declaration

  /*
   * Auxiliares ****************************************************************
   */
  private static void printLog(String s) {
    try {
      dos.writeBytes(s);
    } catch (Exception e) {
      System.err.println("  Error:  no se ha podido escribir en el log");
    }
  }

  private static void println(String s) {
    System.out.println(s);
  }

  private static void print(String s) {
    System.out.print(s);
  }
}
