/**
 * ControlApp.h:  fichero de definiciones de la aplicación ControlApp.
 *
 * @author Agustín Isasa | UOC
 * @date Abril 2012
 */

#ifndef CONTROLAPP_H
#define CONTROLAPP_H

enum {
	// Comandos para enviar al nodo actuador y registrar en log
	NO_COMMAND,					// Definiciones para CommandMsg y SensorMsg
	COMM_MOTOR_OPEN,
	COMM_MOTOR_CLOSE,
	BLIND_CLOSED,				// Definiciones para HallMsg
	BLIND_NOT_CLOSED,
	// Tipos de mensaje
	AM_SENSORSMSG		= 40,
	AM_COMMANDMSG		= 41,
	AM_HALLMSG			= 42,
	AM_PARAMMSG			= 43
};

// Mensaje serie para actualizar log
typedef nx_struct SensorsMsg {
	nx_uint8_t moteId;			// Identificador mote
	nx_uint16_t counter;		// Contador mensajes
	nx_uint16_t countsTemp;		// Valor temperatura
	nx_uint16_t countsPhoto;	// Valor luminosidad
	nx_uint8_t commnd;			// Comando decidido	
	nx_uint8_t timeCmd;			// Tiempo actuación motor en segs.				
} SensorsMsg;

// Mensaje radio con comando a nodo actuador
typedef nx_struct CommandMsg{
	nx_uint8_t moteId;			// Identificador mote
	nx_uint8_t cmd;				// Comando transmitido
	nx_uint8_t timeCmd;			// Tiempo actuación sobre motor
}CommandMsg;

// Mensaje correspondiente a evento Hall
typedef nx_struct HallMsg{
	nx_uint8_t moteId;			// Identificador mote
	nx_uint16_t eventNumber;	// Contador
	nx_uint8_t blindState;		// Persiana cerrada o no cerrada
}HallMsg;

// Mensaje con parámetros aplicación establecidos por usuario
typedef nx_struct ParamMsg{
	nx_uint8_t tMin;
	nx_uint8_t tMax;
	nx_uint16_t freqOp;
}ParamMsg;

#endif /* CONTROLAPP_H */
